<!DOCTYPE html>
<meta name="viewport" content="width=device-width, initial-scale=1">
<html id="fullscreen">

<head>
    <title>Device Debug</title>
    <script src='../js/jquery.min.js'></script>

    <style>
        #debug_data {
            font-family: 'Courier New', Courier, monospace;
            font-size: x-small;
            width: 95%;
            height: 90vh;
            overflow: scroll;
        }

        #balance_length {
            font-size: x-small;
            margin-left: 10px;
        }
    </style>

</head>

<body>
    <div>
        <div>
            <button type="button" id="button_startStop">Stop</button>
            <button type="button" id="button_clear">Clear</button>
            <label id="balance_length">10000</label>
        </div>

        <div id="debug_data">
            Waiting for data....
        </div>

    </div>
</body>

<script>
    $(document).ready(function () {
        $("#testing").scroll(function () {
            if ($(this).scrollTop() + $(this).innerHeight() >= $(this)[0].scrollHeight) {
                $("span").show();
            } else {
                $("span").hide();
            }
        });
    });
</script>

<script>
    $(document).ready(function () {
        // The following lines are for ServerEvents....
        // ServerEvent functions start here....
        var g_serverEventsOk = true;
        var g_serverEventsWaitForRestart = false;
        var timer1 = null;
        var g_log_enabled = true;
        var g_scrollToEnd = true;

        var MAX_LENGTH = 100000;

        $("#balance_length").html(MAX_LENGTH);

        setupEventSource();

        $("#button_clear").on("click", function () {
            $("#debug_data").html("");
        });

        $("#button_startStop").on("click", function () {
            if (g_log_enabled == true) {
                g_log_enabled = false;
                $("#button_startStop").html("Start");
            } else {
                g_log_enabled = true;
                $("#button_startStop").html("Stop");
            }
        });

        $("#debug_data").scroll(function () {
            if ($(this).scrollTop() + $(this).innerHeight() >= $(this)[0].scrollHeight) {
                g_scrollToEnd = true;
            } else {
                g_scrollToEnd = false;
            }
        });

        function setupEventSource() {
            if (typeof (EventSource) !== "undefined") {
                // Use the following line while using in device....
                var source = new EventSource("/debug_event");
                // var source = new EventSource("http://localhost/play/index.php/quickIoT/server_event_test");

                var ev_error = source.onerror = function (ev) {
                    // console.log("Error...");
                    // console.log(ev);
                }

                var ev_message = source.onmessage = function (ev) {
                    g_serverEventsOk = true;
                    if (g_log_enabled == true) {
                        var response = ev.data;

                        var objDiv = $("#debug_data");

                        if (objDiv.html().length > 100000) {
                            objDiv.html("");
                        }

                        if (ev.data.charAt(ev.data.length - 1) == "|") {
                            newVal = objDiv.html() + "<br><br>" + ev.data;
                        } else {
                            newVal = objDiv.html() + ev.data;
                        }

                        objDiv.html(newVal);

                        $("#balance_length").html(MAX_LENGTH - objDiv.html().length);

                        if (g_scrollToEnd == true) {
                            var element = document.getElementById("debug_data");

                            element.scrollIntoView();
                            element.scrollIntoView(false);
                            element.scrollIntoView({ block: "end" });
                            element.scrollIntoView({ behavior: "smooth", block: "end", inline: "nearest" });
                        }
                    }
                }


                if (timer1 != null) {
                    clearInterval(timer1);
                }
                timer1 = setInterval(function () {
                    if (g_serverEventsOk == false) {
                        if (g_serverEventsWaitForRestart == false) {
                            ev_error = null;
                            ev_message = null;

                            if (source != null) {
                                source.close();
                                source = null;
                            }

                            // Minimum 8 seconds + random 8 seconds
                            random = Math.floor(Math.random() * 8000);
                            waitTime = 8000 + random;
                            console.log("Connection closed!!! Restarting in " + waitTime + " ms.. ")

                            g_serverEventsOk = true;
                            g_serverEventsWaitForRestart = true;
                            setTimeout(function () {
                                setupEventSource();
                                g_serverEventsWaitForRestart = false;
                            }, waitTime)
                        }
                    } else {
                        g_serverEventsOk = false;
                    }
                }, 5000);
            } else {
                // document.getElementById("result").innerHTML = ";
                $("#debug_data").html("Sorry, your browser does not support server-sent events...");
            }
        }
        // ServerEvent functions end here....
    });
</script>